package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.matter.MatterRegistry;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterDecomposer;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.slot.MatterySlot;
import ru.dbotthepony.mc.otm.menu.slot.MachineOutputSlot;
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget;
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget;

import javax.annotation.Nullable;

public class MatterDecomposerMenu extends PoweredMatteryMenu {
	public MatterDecomposerMenu(int containerID, Inventory inventory) {
		this(containerID, inventory, null);
	}

	public MatterySlot input;
	public MachineOutputSlot output;
	public ProgressGaugeWidget progress;
	public LevelGaugeWidget matter_widget;

	public MatterDecomposerMenu(int containerID, Inventory inventory, @Nullable BlockEntityMatterDecomposer tile) {
		super(Registry.Menus.MATTER_DECOMPOSER, containerID, inventory, tile);
		Container container = tile != null ? tile.itemContainer : new SimpleContainer(2);

		// Вход
		input = new MatterySlot(container, 0, 61, 36) {
			@Override
			public boolean mayPlace(ItemStack p_40231_) {
				return MatterRegistry.canDecompose(p_40231_);
			}
		};

		addSlot(input);

		// Выход
		output = new MachineOutputSlot(container, 1, 61 + 18 + 10 + 3 + 22, 36, true);
		addSlot(output);

		if (tile == null || tile.getCapability(MatteryCapability.MATTER).resolve().isEmpty()) {
			matter_widget = new LevelGaugeWidget(this);
			progress = new ProgressGaugeWidget(this);
		} else {
			matter_widget = new LevelGaugeWidget(this, tile.getCapability(MatteryCapability.MATTER).resolve().get());
			progress = new ProgressGaugeWidget(this, () -> (float) tile.getWorkProgress(), tile::cantProcessJob);
		}

		addBatterySlot(14);
		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 1;
	}
}
