package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.Registry
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterCapacitorBank
import ru.dbotthepony.mc.otm.capability.matter.IMatterHandler
import ru.dbotthepony.mc.otm.core.Fraction
import ru.dbotthepony.mc.otm.graph.matter.MatterNetworkGraph
import ru.dbotthepony.mc.otm.menu.slot.MatterContainerInputSlot
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget

class MatterCapacitorBankMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory?,
	tile: BlockEntityMatterCapacitorBank? = null
) : MatteryMenu(
	Registry.Menus.MATTER_CAPACITOR_BANK, p_38852_, inventory!!, tile
) {
	val matter_widget: LevelGaugeWidget
	val total_matter_widget: LevelGaugeWidget
	val container_slots = arrayOfNulls<MatterContainerInputSlot>(2 * 6)

	init {
		if (tile == null) {
			matter_widget = LevelGaugeWidget(this)
			total_matter_widget = LevelGaugeWidget(this)
		} else {
			matter_widget = LevelGaugeWidget(this, tile)
			total_matter_widget = LevelGaugeWidget(this, {
				(tile.getAsMatterNode().graph as MatterNetworkGraph?)?.getMatterStorageLevel() ?: Fraction.ZERO
			}, {
				(tile.getAsMatterNode().graph as MatterNetworkGraph?)?.getMatterStorageMaxLevel() ?: Fraction.ZERO
			})
		}

		val container = tile?.matterContainer ?: SimpleContainer(2 * 6)

		for (row in 0..1) {
			for (column in 0..5) {
				container_slots[row * 6 + column] = MatterContainerInputSlot(
					container,
					row * 6 + column,
					44 + column * 18,
					20 + row * 18,
					true,
					IMatterHandler.MatterDirection.BIDIRECTIONAL
				)

				addSlot(container_slots[row * 6 + column]!!)
			}
		}
		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 2 * 6
	}
}